
// AO DC VoltageDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "AO DC Voltage.h"
#include "AO DC VoltageDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CAODCVoltageDlg Ի




CAODCVoltageDlg::CAODCVoltageDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CAODCVoltageDlg::IDD, pParent)
	, Voltage(0)
	, DANum(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAODCVoltageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_DeviceIndex, mDeviceIndexCombo);
	DDX_Text(pDX, IDC_EDIT1, Voltage);
	DDX_CBIndex(pDX, IDC_COMBO_DA_Index, DANum);
	DDX_Control(pDX, IDC_BUTTON_Set, mSetBtn);
}

BEGIN_MESSAGE_MAP(CAODCVoltageDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_Set, &CAODCVoltageDlg::OnBnClickedButtonSet)
END_MESSAGE_MAP()


// CAODCVoltageDlg Ϣ

BOOL CAODCVoltageDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	long CardCount;
	CardCount = FindUSBDAQ();		// ѯǰӲɼ
	
	if(CardCount > 0)
	{
		mSetBtn.EnableWindow(1);
	}
	else
	{
		mSetBtn.EnableWindow(0);
	}
	
	long i;
	CString a;
	char b[6];
	for(i = 0; i < CardCount; i++)
	{
		a = _T("");
		ltoa(i, b, 1);
		a = a + b[0];
		mDeviceIndexCombo.AddString(a);
	}

	mDeviceIndexCombo.SetCurSel(0);

	UpdateData(false);
	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CAODCVoltageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CAODCVoltageDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CAODCVoltageDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CAODCVoltageDlg::OnBnClickedButtonSet()
{
	// TODO: ڴӿؼ֪ͨ
	int temp;

	UpdateData(true);
	DeviceIndex = mDeviceIndexCombo.GetCurSel();	// 趨ǰҪ豸
	temp = OpenDevice(DeviceIndex);					// 豸
	temp = InitDA(DeviceIndex);						// ʼAOͨ
	temp = SetDA(DeviceIndex, DANum, Voltage);		// öӦAOͨѹ
	CloseDevice(DeviceIndex);						// ر豸
}
